#! /bin/bash

# PC/SC服务卸载脚本
# pcscd, pcsc-lite, drivers, pkcs11, user tool
# WatchData

# pcsc daemon名称
DAEMON_NAME=wdpcscd_gdca

# 通讯服务名称
WDSERVER_NAME=WDTokenServer_gdca

# pcsc-lite so库名称
PCSCLITE_LIB_NAME=libpcsclite_wdv5

# 用户工具名称
UKTOOL_NAME=WDUSBKeytool_gdca

# UI进程名称
UI_NAME=WDUIServer_gdca

# WatchData主目录ROOT
DDIR_ROOT=/opt/apps/com.gdca.gdcaclient/files/driver/watch/
DDIR_PCSC=$DDIR_ROOT/pcsc

DDIR_ENTRIES=$DDIR_ROOT/entries
DDIR_APPLICATIONS=$DDIR_ENTRIES/applications

# 快捷方式路径
APP_START_DIR=/usr/share/applications
APP_START_NAME=com.watchdata.uktool.gdca.desktop

# 开机自启动路径
XDG_AUTOSTART_DIR=/etc/xdg/autostart/com.watchdata.tokenserver.gdca.desktop

#终止正在运行的工具
KillTool (){
	toollist=$(ps -ef | grep "$UKTOOL_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$toollist" ];then
		echo "	WDUSBKeytool is running, will stop it ..."
		echo $toollist | while read pid; do
			kill -9 $pid
		done
	fi
}

#终止UI进程
KillUI () {

	UIlist=$(ps -ef | grep "$UI_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$UIlist" ];then
		echo "	UIServer is running, will stop it ..."
		echo $UIlist | while read pid; do
			kill -9 $pid
		done
	fi
}

#终止已运行的服务
KillService () {
	
	#终止服务进程
	pidlist=$(ps -ef | grep "$DAEMON_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$pidlist" ];then
		echo $pidlist | while read pid; do
			kill -9 $pid
		done
		sleep 02s
	fi

	#检查结果
	pidlist=$(ps -ef | grep "$DAEMON_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$pidlist" ];then
		echo "	can't stop $DAEMON_NAME."
		ErrFail
	else
		echo "	$DAEMON_NAME has been stoped."
	fi


	#清理
	if [ -e /tmp/$DAEMON_NAME.comm ]; then
		rm -f /tmp/$DAEMON_NAME.comm
	fi
	if [ -e /tmp/$DAEMON_NAME.pid ]; then
		rm -f /tmp/$DAEMON_NAME.pid
	fi

	serverlist=$(ps -ef | grep "$WDSERVER_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$serverlist" ];then
		echo "	WDTokenServer is running, will stop it ..."
		echo $serverlist | while read pid; do
			kill -9 $pid
		done
	fi
}


# Begin Now !

#关闭正在运行的工具
KillTool

#终止UI进程
KillUI

#终止已运行的服务
KillService

#删除pcsclite软链接
if [ -f $DDIR_PCSC/$PCSCLITE_LIB_NAME.so.1 ]; then
	rm -f $DDIR_PCSC/$PCSCLITE_LIB_NAME.so.1
fi

#删除开始菜单快捷方式
if [ -f $APP_START_DIR/$APP_START_NAME ]; then
	rm -f $APP_START_DIR/$APP_START_NAME
fi

#清理WDTokenServer开机启动项
if [ -f $XDG_AUTOSTART_DIR ]; then
	rm -f $XDG_AUTOSTART_DIR
fi


