#!/bin/sh

# pcsc daemon名称
DAEMON_NAME=wdpcscd_gdca

# 通讯服务名称
WDSERVER_NAME=WDTokenServer_gdca

# 用户工具名称
UKTOOL_NAME=WDUSBKeytool_gdca

# UI进程名称
UI_NAME=WDUIServer_gdca

#终止正在运行的工具
KillTool (){
	toollist=$(ps -ef | grep "$UKTOOL_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$toollist" ];then
		echo "	$UKTOOL_NAME is running, will stop it ..."
		echo $toollist | while read pid; do
		kill -9 $pid
		done
		sleep 02s
		#检查用户进程是否已结束
		toollist=$(ps -ef | grep "$UKTOOL_NAME" | grep -v grep | awk '{print $2}')
		if [ -n "$toollist" ];then
			echo "	can't stop $UKTOOL_NAME."
			ErrFail
		else
			echo "	$UKTOOL_NAME has been stopped."
		fi
	fi

}

#终止UI进程
KillUI () {

	UIlist=$(ps -ef | grep "$UI_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$UIlist" ];then
		echo "	$UI_NAME is running, will stop it ..."
		echo $UIlist | while read pid; do
			kill -9 $pid
		done
		sleep 02s
		
		#检查UIServer进程是否结束
		UIlist=$(ps -ef | grep "$UI_NAME" | grep -v grep | awk '{print $2}')
		if [ -n "$UIlist" ];then
			echo "	can't stop $UI_NAME."
			ErrFail
		else
			echo "	$UI_NAME has been stopped."
		fi
	fi


}

#终止已运行的服务
KillService () {
	
	#终止服务进程
	pidlist=$(ps -ef | grep "$DAEMON_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$pidlist" ];then
		echo "	$DAEMON_NAME is running, will stop it ..."
		echo $pidlist | while read pid; do
		kill -9 $pid
		done
		sleep 02s
		
		#检查wdpcscd服务进程是否结束
		pidlist=$(ps -ef | grep "$DAEMON_NAME" | grep -v grep | awk '{print $2}')
		if [ -n "$pidlist" ];then
			echo "	can't stop $DAEMON_NAME."
			ErrFail
		else
			echo "	$DAEMON_NAME has been stopped."
		fi
	fi



	#清理
	if [ -e /tmp/$DAEMON_NAME.comm ]; then
		rm -f /tmp/$DAEMON_NAME.comm
	fi
	if [ -e /tmp/$DAEMON_NAME.pid ]; then
		rm -f /tmp/$DAEMON_NAME.pid
	fi

	serverlist=$(ps -ef | grep "$WDSERVER_NAME" | grep -v grep | awk '{print $2}')
	if [ -n "$serverlist" ];then
		echo "	$WDSERVER_NAME is running, will stop it ..."
		echo $serverlist | while read pid; do
		kill -9 $pid
		done
		sleep 02s

		#检查WDTokenServer进程是否结束
		serverlist=$(ps -ef | grep "$WDSERVER_NAME" | grep -v grep | awk '{print $2}')
		if [ -n "$serverlist" ];then
			echo "	can't stop $WDSERVER_NAME."
			ErrFail
		else
			echo "	$WDSERVER_NAME has been stopped."
		fi

	fi
}


