#!/bin/sh

# pcsc-lite so库名称
PCSCLITE_LIB_NAME=libpcsclite_wdv5

#udev规则 用于解决无权限访问设备的问题
DDIR_UDEV_RULES=/etc/udev/rules.d
UDEV_RULE_FILE=60-wdukey-gdca.rules

# WatchData主目录
DDIR_ROOT=/opt/apps/com.gdca.gdcaclient/files/driver/watch/
DDIR_PCSC=$DDIR_ROOT/pcsc
WDSERVER_PATH=$DDIR_PCSC/WDTokenServer_gdca

DDIR_ENTRIES=$DDIR_ROOT/entries
DDIR_APPLICATIONS=$DDIR_ENTRIES/applications

# 快捷方式路径
APP_START_DIR=/usr/share/applications
APP_START_NAME=com.watchdata.gdca.desktop

source $(dirname "$0")/common.sh

#关闭正在运行的工具
KillTool

#终止UI进程
KillUI

#终止已运行的服务
KillService

#安装udev规则文件
if [  ! -f $DDIR_UDEV_RULES/$UDEV_RULE_FILE ]; then
    if [ -e $DDIR_ROOT/udev/$UDEV_RULE_FILE ]; then
		cp -fpR $DDIR_ROOT/udev/$UDEV_RULE_FILE $DDIR_UDEV_RULES/
	fi
fi

# 添加libpcsclite软链接
if [  ! -f $DDIR_PCSC/$PCSCLITE_LIB_NAME.so.1 ]; then
	ln -sf $DDIR_PCSC/$PCSCLITE_LIB_NAME.so.1.0.0 $DDIR_PCSC/$PCSCLITE_LIB_NAME.so.1
fi

#创建开始菜单快捷方式
#if [  ! -f $APP_START_DIR/$APP_START_NAME ]; then
#	ln -sf $DDIR_APPLICATIONS/$APP_START_NAME $APP_START_DIR/$APP_START_NAME
#fi




chmod +x $WDSERVER_PATH

#启动 WDTokenServer
#$WDSERVER_PATH &

